org.eclipse.wst.jsdt.core

## Interface IAccessRule

    public interface IAccessRule

Describes an access rule to source and class files on a includepath entry. An access rule is composed of a file pattern and a kind (accessible, non accessible, or discouraged).

On a given includepath entry, the access rules are considered in the order given when the entry was created. When a source matches an access rule's pattern, the access rule's kind define whether the file is considered accessible, non accessible, or its access is discouraged. If the source file doesn't match any accessible rule, it is considered accessible. A source file that is not accessible or discouraged can still be refered to but it is tagged as being not accessible - the JavaScript validator will create a problem marker for example. The severity of the marker created from a non accessible rule is controled through the `JavaScriptCore.COMPILER_PB_FORBIDDEN_REFERENCE` compiler option. The severity of the marker created from a discouraged rule is controled through the `JavaScriptCore.COMPILER_PB_DISCOURAGED_REFERENCE` compiler option. Note this is different from inclusion and exclusion patterns on source includepath entries, where a source file that is excluded is not even validated. Files patterns look like relative file paths with wildcards and are interpreted relative to each entry's path. File patterns are case-sensitive and they can contain '**', '*' or '?' wildcards (see `IIncludePathEntry.getExclusionPatterns()` for the full description of their syntax and semantics). Note that file patterns must not include the file extension. `com/xyz/tests/MyClass` is a valid file pattern, whereas `com/xyz/tests/MyClass.class` is not valid.

Provisional API: This class/interface is part of an interim API that is still under development and expected to change significantly before reaching stability. It is being made available at this early stage to solicit feedback from pioneering adopters on the understanding that any code that uses this API will almost certainly be broken (repeatedly) as the API evolves.

### Field Summary

Fields
`static int` `IGNORE_IF_BETTER` Flag indicating that whether a type matching this rule should be ignored iff a type with the same qualified name can be found on a later includepath entry with a better accessibility.
`static int` `K_ACCESSIBLE` Constant indicating that files matching the rule's pattern are accessible.
`static int` `K_DISCOURAGED` Constant indicating that access to the files matching the rule's pattern is discouraged.
`static int` `K_NON_ACCESSIBLE` Constant indicating that files matching the rule's pattern are non accessible.

### Method Summary

All Methods Instance Methods Abstract Methods
`int` `getKind()` Returns the kind of this access rule (one of `K_ACCESSIBLE`, `K_NON_ACCESSIBLE` or `K_DISCOURAGED`).
`IPath` `getPattern()` Returns the file pattern for this access rule.
`boolean` `ignoreIfBetter()` Returns whether a type matching this rule should be ignored iff a type with the same qualified name can be found on a later includepath entry with a better accessibility.

### Field Detail

#### K_ACCESSIBLE

    static final int K_ACCESSIBLE

Constant indicating that files matching the rule's pattern are accessible.

See Also:
  Constant Field Values

#### K_NON_ACCESSIBLE

    static final int K_NON_ACCESSIBLE

Constant indicating that files matching the rule's pattern are non accessible.

See Also:
  Constant Field Values

#### K_DISCOURAGED

    static final int K_DISCOURAGED

Constant indicating that access to the files matching the rule's pattern is discouraged.

See Also:
  Constant Field Values

#### IGNORE_IF_BETTER

    static final int IGNORE_IF_BETTER

Flag indicating that whether a type matching this rule should be ignored iff a type with the same qualified name can be found on a later includepath entry with a better accessibility.

E.g. if a type p.X matches a rule K_NON_ACCESSIBLE | IGNORE_IF_BETTER on a library entry 'lib1' and another type p.X also matches a rule K_DISCOURAGED on library entry 'lib2' ('lib2' being after 'lib1' on the includepath), then p.X from 'lib2' will be used and reported as discouraged.

See Also:
  Constant Field Values

### Method Detail

#### getPattern

    IPath getPattern()

Returns the file pattern for this access rule.

Returns:
  the file pattern for this access rule

#### getKind

    int getKind()

Returns the kind of this access rule (one of `K_ACCESSIBLE`, `K_NON_ACCESSIBLE` or `K_DISCOURAGED`).

Returns:
  the kind of this access rule

#### ignoreIfBetter

    boolean ignoreIfBetter()

Returns whether a type matching this rule should be ignored iff a type with the same qualified name can be found on a later includepath entry with a better accessibility.

E.g. if a type p.X matches a rule K_NON_ACCESSIBLE | IGNORE_IF_BETTER on a library entry 'lib1' and another type p.X also matches a rule K_DISCOURAGED on library entry 'lib2' ('lib2' being after 'lib1' on the includepath), then p.X from 'lib2' will be used and reported as discouraged.

Returns:
  whether a type matching this rule should be ignored iff a type with the same qualified name can be found on a later includepath entry with a better accessibility